// **********************************************************************
//
// Copyright (c) 2001 MT Tools.
//
// All Rights Reserved
//
// MT_DORB is based in part on the product DORB,
// written by Shadrin Victor
//
// See Readme.txt for contact information
//
// **********************************************************************
unit cosnaming_int;

{$MINENUMSIZE 4}

interface

uses
  code_int,orb_int,orbtypes, except_int;

type

  INamingContext = interface;

  IBindingIterator = interface;

  // module CosNaming types

  TIstring = string;

  PNameComponent = ^TNameComponent;
  TNameComponent = record
    id : TIstring;
    kind : TIstring;
  end;

  TName = array of TNameComponent;

  TBindingType = (
    nobject,
    ncontext
  );

  TBinding = record
    binding_name : TName;
    binding_type : TBindingType;
  end;

  TBindingList = array of TBinding;

  TNamingContext_NotFoundReason = (
    missing_node,
    not_context,
    not_object
  );

  INamingContext_NotFound = interface(IUserException)
  ['{8C9CDD00-E665-11D4-9E2F-204C4F4F5020}']
    function why: TNamingContext_NotFoundReason; overload;
    procedure why(const val : TNamingContext_NotFoundReason); overload;
    function rest_of_name: TName; overload;
    procedure rest_of_name(const val : TName); overload;
  end;

  INamingContext_CannotProceed = interface(IUserException)
  ['{8C9CDD01-E665-11D4-9E2F-204C4F4F5020}']
    function cxt: INamingContext; overload;
    procedure cxt(const val : INamingContext); overload;
    function rest_of_name: TName; overload;
    procedure rest_of_name(const val : TName); overload;
  end;

  INamingContext_InvalidName = interface(IUserException)
  ['{8C9CDD02-E665-11D4-9E2F-204C4F4F5020}']
  end;

  INamingContext_AlreadyBound = interface(IUserException)
  ['{8C9CDD03-E665-11D4-9E2F-204C4F4F5020}']
  end;

  INamingContext_NotEmpty = interface(IUserException)
  ['{8C9CDD04-E665-11D4-9E2F-204C4F4F5020}']
  end;

  INamingContext = interface
  ['{8C9CDD05-E665-11D4-9E2F-204C4F4F5020}']
    procedure bind(const n: TName; const obj: IORBObject);
    procedure rebind(const n: TName; const obj: IORBObject);
    procedure bind_context(const n: TName; const nc: INamingContext);
    procedure rebind_context(const n: TName; const nc: INamingContext);
    function resolve(const n: TName): IORBObject;
    procedure unbind(const n: TName);
    function new_context: INamingContext;
    function bind_new_context(const n: TName): INamingContext;
    procedure _destroy;
    procedure list(const how_many: _ulong; out bl: TBindingList; out bi: IBindingIterator);
  end;

  IBindingIterator = interface
  ['{8C9CDD06-E665-11D4-9E2F-204C4F4F5020}']
    function next_one(out b: TBinding): boolean;
    function next_n(const how_many: _ulong; out bl: TBindingList): boolean;
    procedure _destroy;
  end;

  TNamingContextExt_StringName = string;

  TNamingContextExt_Address = string;

  TNamingContextExt_URLString = string;


  INamingContextExt_InvalidAddress = interface(IUserException)
  ['{80EDCB0E-C7EE-49E7-848A-C9958A76CFBF}']
  end;

  INamingContextExt = interface(INamingContext)
  ['{92D6834F-E781-403A-81FA-A8CC108CB93A}']
    function to_string(const n: TName): TNamingContextExt_StringName;
    function to_name(const sn: TNamingContextExt_StringName): TName;
    function to_url(const addr: TNamingContextExt_Address; const sn: TNamingContextExt_StringName): TNamingContextExt_URLString;
    function resolve_str(const n: TNamingContextExt_StringName): IORBObject;
  end;


implementation

end.
